#!/usr/bin/env python

import os
import sys
import re
import string

def isList(essid):
	list = get_ap_list()
	for x in list:
		if x == essid:
			return 1
	return 0

def get_ap_list():
	str = read_iwlist()
	if len(str) <= 1:
		print 'exception'

	APList = parser(str)
	list = []
	if APList:
		for ap in APList:
			entry = APList[ap]
			list.append(entry['essid'])
	else:
		print 'Not ap List'

	return list
		
def read_file(path):
	if not os.path.exists(path):
		# exception
		pass

	fd = open(path, 'r')
	str = fd.read()
	fd.close()

	return str

def read_iwlist():
	path_list = ['/sbin','/bin','/usr/sbin','/usr/bin']
	real_path = '/sbin/iwlist';
	for p in path_list:
		full_path = os.path.join(p, 'iwlist')
		if os.path.exists(full_path):
			real_path = full_path
			break
	fd = os.popen('%s scan' % real_path)
	str = fd.read()
	fd.close()
	
	return str

def parser(str):
	if not len(str):
		return;

	ap_blocks = str.split('Cell')
	APList = {}

	for block in ap_blocks:
		lines = block.split('\n')
		mBitrate = 0;
		mId = mAddress = mEssid = mQuality = ''
		for line in lines:
			# strip white space
			line = line.strip()
			if line.find('Address:') >= 0:
				id, address = re.split('-\s*Address:', line)
				mId = id.strip()
				mAddress = address.strip()
			elif line.find('ESSID:') >= 0:
				mEssid = line[line.find('ESSID:')+6:].split('"')[1]
			elif line.find('Quality=') >= 0:
				qarr = re.findall('Quality=[0-9]+/[0-9]+', line)[0].split('=')
				mQuality = qarr[1]
			elif line.find('Bit Rate:') >= 0:
				bitrate = re.split('Bit Rate:', line)[1]
				bitrate = re.findall('[0-9]+', bitrate)[0]
				if not bitrate.isdigit():
					# exception
					pass		
				if string.atoi(bitrate) > mBitrate:
					mBitrate = string.atoi(bitrate)
	
		if not mAddress:
			continue
		entry = {}
		entry['address'] = mAddress
		entry['essid'] = mEssid
		entry['quality'] = mQuality
		entry['bitrate'] = mBitrate

		APList['%s' % mId] = entry;
		
		#print '>>> ', APList['%s' % mId]['address'], APList['%s' % mId]['essid'], APList['%s' % mId]['quality'], APList['%s' % mId]['bitrate']

	return APList;
