#!/usr/bin/env python
#
# vim:ts=8:sw=4
# file: icfg_manager.py

import os
import sys

IFCFG_FILE_DIR = '/etc/sysconfig/network-scripts/'

class Convertor:
	def convert_ap(self, data=None):
		if not data:
			print 'argument is nothing'
			sys.exit(1)
		if type(data) != type({}):
			print 'data is not same argument type list'
			sys.exit(1)
		
		#print data, '<<<<<<<<<<<'
		manager = IfcfgManager()
		
		manager.ifcfg[manager.ifcfg_title[0]] = data['interface']
		manager.ifcfg[manager.ifcfg_title[1]] = data['essid']
		manager.ifcfg[manager.ifcfg_title[2]] = 'Wireless'
		manager.ifcfg[manager.ifcfg_title[8]] = 'on'
		if data['radio'] == 'dhcp':
			manager.ifcfg[manager.ifcfg_title[3]] = 'dhcp'
		elif data['radio'] == 'static':
			manager.ifcfg[manager.ifcfg_title[3]] = 'static'
			manager.ifcfg[manager.ifcfg_title[4]] = data['ip']
			manager.ifcfg[manager.ifcfg_title[5]] = data['network']
			manager.ifcfg[manager.ifcfg_title[6]] = data['netmask']
		else:
			print 'oops:bootproto is empty'
			sys.exit(1)

		return manager, data['interface']
	
	def convert_profile(self, data=None):
		if not data:
			print 'argument is nothing'
			sys.exit(1)
		if type(data) != type([]):
			print 'data is not same argument type list'
			sys.exit(1)
		
		manager = IfcfgManager()
		manager.ifcfg[manager.ifcfg_title[0]] = data[1]
		manager.ifcfg[manager.ifcfg_title[1]] = data[2]
		manager.ifcfg[manager.ifcfg_title[2]] = 'Wireless'
		manager.ifcfg[manager.ifcfg_title[8]] = 'on'
		if data[3] == 0:
			manager.ifcfg[manager.ifcfg_title[3]] = 'dhcp'
		elif data[3] == 1:
			manager.ifcfg[manager.ifcfg_title[3]] = 'static'
			value = data[4]
			manager.ifcfg[manager.ifcfg_title[4]] = value[0]
			manager.ifcfg[manager.ifcfg_title[5]] = value[1]
			manager.ifcfg[manager.ifcfg_title[6]] = value[2]
		else:
			print 'oops:bootproto is empty'
			sys.exit(1)

		return manager, data[1]

	def __init__(self):
		print 'converting profile to ifcfg-#N'
		pass


class IfcfgManager:
	def is_exist_ifcfg(self, device=None):
		if not device:
			print 'argument is nothing'
			sys.exit(1)
	
		find_ifcfg = 'ifcfg-' + device
		file_list = os.listdir(IFCFG_FILE_DIR)
		for file in file_list:
			if file == find_ifcfg:
				return 1

		return None

	def read_ifcfg(self, device=None):
		print 'ifcfg file reading...'
		if not device:
			print 'I think that this module is not necessary.\n so I don\'t implementation.\n But I must be to think more than.'
			print 'device is empty'
			sys.exit(1)

		if not is_exist_ifcfg(device):
			print 'this ifcfg-%s is not exist'
			sys.exit(1)

		path = IFCFG_FILE_DIR + 'ifcfg-' + device
		fo = open(path, 'r')
		
		for line in fo.readlines():
			if line[0] == '#':
				#print 'this statement is comment: %s' % line
				continue
			self.ifcfg[line.split('=')[0]] = line.split('=')[1].split('\n')[0]
		
	def write_ifcfg(self):
		print 'ifcfg file writting...'
		if not self.ifcfg.has_key(self.ifcfg_title[0]):
			print 'device is empty'
			sys.exit(1)

		device = self.ifcfg[self.ifcfg_title[0]]
		if not device:
			print 'device is empty'
			sys.exit(1)

		path = IFCFG_FILE_DIR + 'ifcfg-' + device
		fw = open(path, 'w')
		fw.write('# This file is ifcfg file using booyo-config-wireless\n')
		for index in self.ifcfg.keys():
			fw.write(index + '=' + self.ifcfg[index] + '\n')
		fw.close()

	def __init__(self):
		print 'ifcfg manager constructor'
		self.ifcfg_title = ['DEVICE', 'ESSID', 'TYPE', 'BOOTPROTO', 'IPADDR', 'NETMASK', 'NETWORK', 'BROADCAST', 'ONBOOT']
		self.ifcfg = {}


## Original_Source
##
#import booyo_util
#import net_device_manager
#
#class IfcfgParser:
#    def set_device(self, device=None):
#    	if not device:
#		return
#
#    	self.DIC_DATA['DEVICE'] = device
#
#    def set_essid(self, essid=None):
#    	if not essid:
#		return
#
#	self.DIC_DATA['ESSID'] = essid
#
#    def set_type(self, type=None):
#    	if not type:
#		return
#
#    	self.DIC_DATA['TYPE'] = type
#    
#    def set_bootproto(self, hdcp=None):
#    	if not hdcp:
#		return
#
#    	self.DIC_DATA['BOOTPROTO'] = dhcp
#
#    def set_ipaddr(self, ip=None):
#    	if not ip:
#		return
#
#    	self.DIC_DATA['IPADDR'] = ip
#
#    def set_netmask(self, netmask=None):
#    	if not netmask:
#		return
#
#    	self.DIC_DATA['NETMASK'] = netmask
#
#    def set_network(self, network=None):
#    	if not network:
#		return
#
#    	self.DIC_DATA['NETWORK'] = network
#
#    def set_broadcast(self, broadcast=None):
#    	if not broadcast:
#		return
#
#    	self.DIC_DATA['BROADCAST'] = broadcast
#
#    def set_onboot(self, onboot=None):
#    	if not onboot:
#		return
#
#    	self.DIC_DATA['ONBOOT'] = onboot
#    
#    def is_list_attr(self, data=None):
#    	if not data:
#		print '잘못된 매개변수'
#		return 0, '잘못된 매개변수'
#
#	for x in self.LIST_ATTR:
#		if booyo_util.isCompare(x, data):
#			return 1, '같음'
#
#	return 0, '다르다'
#
#    def get_essid(self):
#	return self.DIC_DATA['ESSID']
#
#    def get_data(self):
#	return self.DIC_DATA
#
#    def write(self):
#	if (self.DIC_DATA['DEVICE'] == 0) and (len(self.DIC_DATA['DEVICE']) == 0):
#		return
#	elif (self.DIC_DATA['TYPE'] == 0) and (len(self.DIC_DATA['TYPE']) == 0):
#		return
#	else:
#		abs_path_filename = self.IFCFG_SYSDIR + self.DIC_DATA['DEVICE']
#		fo = open(abs_path_filename.split('\n')[0], "w")
#		for x in self.DIC_DATA.keys():
#			str = x + "=" + self.DIC_DATA[x]
#			fo.write(str)
#		fo.close()
#
#    def __init__(self, device=None):
#	if device == None:
#		return
#
#	abs_filename = self.IFCFG_SYSDIR + device
#	fi = open(abs_filename, "r")
#	for s in fi.readlines():
#		if s[0] == '#':
#			print 'This is comment : ', s
#			continue
#		title = s.split('=')[0]
#		if self.is_list_attr(title):
#			self.DIC_DATA[title] = s.split('=')[1]
#	fi.close()
#
#    DIC_DATA = {}
#    IFCFG_SYSDIR = '/etc/sysconfig/network-scripts/ifcfg-'
#    LIST_ATTR = ['DEVICE', 'ESSID', 'TYPE', 'BOOTPROTO', 'IPADDR', 'NETMASK', 'NETWORK', 'BROADCAST', 'ONBOOT']
#
#if __name__ == "__main__":
#    IfcfgParser()
