#!/usr/bin/env python

import os
import string
import gtk
import gobject
import fcntl

def network_restart_ext(dialog=None, interface=None):
	#print 'network restart'
	if (not dialog) or (not interface):
		print 'interface is not defined'
		sys.exit(1)

	if network_stop(interface):
		return network_start_ext(dialog, interface)
	return False

def network_start_ext(dialog, interface=None):
	print 'network start'
	command = '/sbin/ifup ' + interface 
	fo = os.popen(command, 'r')
	fcntl.fcntl(fo.fileno(), fcntl.F_SETFL, os.O_NONBLOCK)
	gobject.io_add_watch(fo, gobject.IO_IN | gobject.IO_HUP, my_callback, dialog)
	ret = dialog.run()
	fo.close()
	return ret

def network_stop(interface=None):
	print 'network stop'
	command = '/sbin/ifdown'
	return network_func(command, interface)

def network_func(command, interface=None):
	if not os.path.exists(command):
		print 'ifup command not found.'
		return False

	if interface:
		command = command + ' ' + interface
		# XXX block... system function
		if os.system(command) == 0:
			return True

		return False
	else:
		print 'interface not found...'

######################
# Callback Functions #
######################
def my_callback(source, condition, dialog):
	if condition == gobject.IO_HUP:
		#print 'pipe is broken'
		dialog.response(gtk.RESPONSE_DELETE_EVENT)
		return False
	else:
		#print 'pipe readable'
		line = source.read(256)
		if line == ' 완료.\n' or line == ' done.\n':
			dialog.response(100)
			return False
		if len(line) == 0:
			#print 'pipe closed'
			dialog.response(gtk.RESPONSE_DELETE_EVENT)
			return False
		#print len(line)
		return True

def network_restart(interface=None):
	print 'network restart'
	if not interface:
		print 'interface is not defined'
		sys.exit(1)

	if network_stop(interface):
		return network_start(interface)
	return False

def network_start(interface=None):
	return network_func(command, interface)
		
class NetDevManager:
	def find_wireless(self, path):
		fi = open(path, "r")
		for line in fi.readlines():
			s = line.split('=')
			if s[0].lower() == 'type':
				if s[1].lower().find('wireless') >= 0: 
					fi.close()
					return True
		fi.close()
		return False

	def dir_listing(self):
		dir_list = os.listdir(self.NET_DEVICE_DIR)
		self.m_device_list = []

		for x in dir_list:
			if x.split('-')[0] == 'ifcfg':
				result = self.find_wireless(self.NET_DEVICE_DIR + x)
				if result == 1:
					self.m_device_list.append(x.split('-')[1])

	def get_device_list(self):
		return self.m_device_list

	def get_default_device(self):
		if not self.m_device_list:
			return 0
		return self.m_device_list[0]

	def __init__(self):
		self.dir_listing()

    # Global Variables	
	NET_DEVICE_DIR = '/etc/sysconfig/network-scripts/'
	m_device_list = []
 

if __name__ == "__main__":
    NetDevManager()
