#!/usr/bin/env python
# vim:ts=8:sw=4

import pygtk
pygtk.require('2.0')
import os
import gtk
import sys
import string

sys.path.append('../backend')
import net_device_manager

class BaseDialogClass:
	def init_interface(self, interface_list=None):
		#'''for override'''
		#pass
		if interface_list:
			self.combo_interface.set_popdown_strings(interface_list)
		else:
			netManager = net_device_manager.NetDevManager()
                	slist = netManager.get_device_list()
                	if len(slist) == 0:
                        	slist = ['Nothing']
                	self.combo_interface.set_popdown_strings(slist)
	
	def init_essid(self, essid_list=None):
		'''for override'''
		pass

	def init_dialog(self):
	    	self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		#self.window.connect("destroy", self.destroy)
		self.window.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.window.set_border_width(5)
		#self.window.set_size_request(400, 300)
		self.window.set_modal(True)

		self.window.set_title("BaseDialog")
		self.window.set_resizable(False)

		main_vbox = gtk.VBox(False, 1)
		main_vbox.set_border_width(1)

		## Profile 
		self.profile_layout = gtk.HBox(False, 1)
		self.profile_layout.set_border_width(1)

		label_profile = gtk.Label(_('Profile Nmae : '))
		label_profile.set_size_request(100,20)
		label_profile.set_alignment(0,0)
		self.profile_layout.pack_start(label_profile, False, False, 0)
		label_profile.show()

		self.entry_profile = gtk.Entry()
		self.entry_profile.set_max_length(15)
		#self.entry_profile.connect("activate", self.enter_callback, self.entry_profile)
		self.entry_profile.set_text("default")
		self.entry_profile.select_region(0, len(self.entry_profile.get_text()))
		self.profile_layout.pack_start(self.entry_profile, True, False, 0)
		self.entry_profile.show()

		main_vbox.pack_start(self.profile_layout, True, False, 0)
		self.profile_layout.show()

		## Interface
		hbox2 = gtk.HBox(False, 1)
		hbox2.set_border_width(1)

		label_interface = gtk.Label(_('Interface : '))
		label_interface.set_size_request(100,20)
		label_interface.set_alignment(0,0)
		hbox2.pack_start(label_interface, False, False, 0)
		label_interface.show()

		self.combo_interface = gtk.Combo()
		self.combo_interface.entry.set_editable(False)
		hbox2.pack_start(self.combo_interface, True, False, 0)
		self.combo_interface.show()

		#main_vbox.pack_start(hbox2, False, False, 0)
		main_vbox.pack_start(hbox2, True, False, 0)
		hbox2.show()
		
		## ESSID  
		hbox3 = gtk.HBox(False, 1)
		hbox3.set_border_width(1)

		label_essid = gtk.Label("ESSID : ")
		label_essid.set_size_request(100,20)
		label_essid.set_alignment(0,0)
		hbox3.pack_start(label_essid, False, False, 0)
		label_essid.show()

		self.combo_essid = gtk.Combo()
		self.combo_essid.entry.set_editable(False)
		hbox3.pack_start(self.combo_essid, True, False, 0)
		self.combo_essid.show()

		#main_vbox.pack_start(hbox3, False, False, 0)
		main_vbox.pack_start(hbox3, True, False, 0)
		hbox3.show()

		## Network info - DHCP
		hbox4 = gtk.HBox(False, 1)
		hbox4.set_border_width(1)

		self.radio_button1 = gtk.RadioButton(None, "DHCP")
		#hbox4.pack_start(self.radio_button1, False, False, 0)
		hbox4.pack_start(self.radio_button1, True, True, 0)
		self.radio_button1.set_active(True)
		self.radio_button1.show()

		#main_vbox.pack_start(hbox4, False, False, 0)
		main_vbox.pack_start(hbox4, True, True, 0)
		hbox4.show()
		
		## Network info - Static IP
		hbox5 = gtk.HBox(False, 1)
		hbox5.set_border_width(1)

		self.radio_button2 = gtk.RadioButton(self.radio_button1, "STATIC")
		#hbox5.pack_start(self.radio_button2, False, False, 0)
		hbox5.pack_start(self.radio_button2, True, True, 0)
		self.radio_button2.show()

		#main_vbox.pack_start(hbox5, False, False, 0)
		main_vbox.pack_start(hbox5, True, True, 0)
		hbox5.show()
		
		## Network info - Static IP layout
		hbox6 = self.init_static_layout()
		#main_vbox.pack_start(hbox6, False, False, 0)
		main_vbox.pack_start(hbox6, True, True, 0)
		hbox6.show()

		## Separator
		sep = gtk.HSeparator()
		sep.show()
		main_vbox.pack_start(sep, True, False, 0)

		## Button
		hbox7 = gtk.HBox(False, 1)
		hbox7.set_border_width(1)

		ok_button = gtk.Button("OK", gtk.STOCK_OK)
		ok_button.set_size_request(100,30)
		ok_button.connect("clicked", self.callback_ok_button, "OK", self.window)
		#hbox7.pack_end(ok_button, False, False, 0)
		hbox7.pack_end(ok_button, False, True, 0)
		ok_button.show()

		main_vbox.pack_start(hbox7, True, False, 0)
		hbox7.show()

		self.window.add(main_vbox)
		main_vbox.show()
		self.window.show()

	def init_static_layout(self):

		hbox1 = gtk.HBox(False, 1)
		hbox1.set_border_width(1)

		#frame = gtk.Frame()
		frame = gtk.Frame(" STATIC ")
		frame.set_border_width(10)
		frame.set_size_request(300, 110)
		frame.set_sensitive(False)
		self.radio_flag = False
		#hbox1.pack_start(frame, False, True, 0)
		hbox1.pack_start(frame, True, True, 0)
		frame.show()

		vbox1 = gtk.VBox(False, 1)
		vbox1.set_border_width(1)
		frame.add(vbox1)
		vbox1.show()

		## IP Address
		hbox2 = gtk.HBox(False, 1)
		hbox2.set_border_width(1)
		vbox1.pack_start(hbox2, False, False, 0)
		hbox2.show()

		label_ip = gtk.Label("IP Address : ")
		label_ip.set_size_request(100,20)
		label_ip.set_alignment(1,0)
		hbox2.pack_start(label_ip, False, False, 0)
		label_ip.show()

		self.entry_ip1 = gtk.Entry()
		self.entry_ip1.set_max_length(3)
		self.entry_ip1.set_size_request(30,20)
		hbox2.pack_start(self.entry_ip1, False, False, 0)
		self.entry_ip1.show()

		label_dot1 = gtk.Label(".")
		hbox2.pack_start(label_dot1, False, False, 0)
		label_dot1.show()

		self.entry_ip2 = gtk.Entry()
		self.entry_ip2.set_max_length(3)
		self.entry_ip2.set_size_request(30,20)
		hbox2.pack_start(self.entry_ip2, False, False, 0)
		self.entry_ip2.show()

		label_dot2 = gtk.Label(".")
		hbox2.pack_start(label_dot2, False, False, 0)
		label_dot2.show()

		self.entry_ip3 = gtk.Entry()
		self.entry_ip3.set_max_length(3)
		self.entry_ip3.set_size_request(30,20)
		hbox2.pack_start(self.entry_ip3, False, False, 0)
		self.entry_ip3.show()

		label_dot3 = gtk.Label(".")
		hbox2.pack_start(label_dot3, False, False, 0)
		label_dot3.show()

		self.entry_ip4 = gtk.Entry()
		self.entry_ip4.set_max_length(3)
		self.entry_ip4.set_size_request(30,20)
		hbox2.pack_start(self.entry_ip4, False, False, 0)
		self.entry_ip4.show()

		## Default Gateway
		hbox3 = gtk.HBox(False, 1)
		hbox3.set_border_width(1)
		vbox1.pack_start(hbox3, False, False, 0)
		hbox3.show()

		label_gateway = gtk.Label("Gateway : ")
		label_gateway.set_size_request(100,20)
		label_gateway.set_alignment(1,0)
		hbox3.pack_start(label_gateway, False, False, 0)
		label_gateway.show()

		self.entry_gate = gtk.Entry()
		self.entry_gate.set_max_length(3)
		self.entry_gate.set_size_request(30,20)
		hbox3.pack_start(self.entry_gate, False, False, 0)
		self.entry_gate.show()

		label_dot11 = gtk.Label(".")
		hbox3.pack_start(label_dot11, False, False, 0)
		label_dot11.show()

		self.entry_net2 = gtk.Entry()
		self.entry_net2.set_max_length(3)
		self.entry_net2.set_size_request(30,20)
		hbox3.pack_start(self.entry_net2, False, False, 0)
		self.entry_net2.show()

		label_dot12 = gtk.Label(".")
		hbox3.pack_start(label_dot12, False, False, 0)
		label_dot12.show()

		self.entry_net3 = gtk.Entry()
		self.entry_net3.set_max_length(3)
		self.entry_net3.set_size_request(30,20)
		hbox3.pack_start(self.entry_net3, False, False, 0)
		self.entry_net3.show()

		label_dot13 = gtk.Label(".")
		hbox3.pack_start(label_dot13, False, False, 0)
		label_dot13.show()

		self.entry_net4 = gtk.Entry()
		self.entry_net4.set_max_length(3)
		self.entry_net4.set_size_request(30,20)
		hbox3.pack_start(self.entry_net4, False, False, 0)
		self.entry_net4.show()

		## Netmask
		hbox4 = gtk.HBox(False, 1)
		hbox4.set_border_width(1)
		vbox1.pack_start(hbox4, False, False, 0)
		hbox4.show()

		label_netmask = gtk.Label("Netmask : ")
		label_netmask.set_size_request(100,20)
		label_netmask.set_alignment(1,0)
		hbox4.pack_start(label_netmask, False, False, 0)
		label_netmask.show()

		self.entry_mask1 = gtk.Entry()
		self.entry_mask1.set_max_length(3)
		self.entry_mask1.set_size_request(30,20)
		hbox4.pack_start(self.entry_mask1, False, False, 0)
		self.entry_mask1.show()

		label_dot21 = gtk.Label(".")
		hbox4.pack_start(label_dot21, False, False, 0)
		label_dot21.show()

		self.entry_mask2 = gtk.Entry()
		self.entry_mask2.set_max_length(3)
		self.entry_mask2.set_size_request(30,20)
		hbox4.pack_start(self.entry_mask2, False, False, 0)
		self.entry_mask2.show()

		label_dot22 = gtk.Label(".")
		hbox4.pack_start(label_dot22, False, False, 0)
		label_dot22.show()

		self.entry_mask3 = gtk.Entry()
		self.entry_mask3.set_max_length(3)
		self.entry_mask3.set_size_request(30,20)
		hbox4.pack_start(self.entry_mask3, False, False, 0)
		self.entry_mask3.show()

		label_dot23 = gtk.Label(".")
		hbox4.pack_start(label_dot23, False, False, 0)
		label_dot23.show()

		self.entry_mask4 = gtk.Entry()
		self.entry_mask4.set_max_length(3)
		self.entry_mask4.set_size_request(30,20)
		hbox4.pack_start(self.entry_mask4, False, False, 0)
		self.entry_mask4.show()

		self.radio_button1.connect("toggled", self.callback_dhcp_radio_button, "radio button 1", frame)
		self.radio_button2.connect("toggled", self.callback_static_radio_button, "radio button 2", frame)
		
		return hbox1

	def set_title(self, str):
		self.window.set_title(str)

	def set_dialog_data(self, data=None):
		if not data:
			print 'argument is nothing'
			sys.exit(1)
		if type(data) != type([]):
			print 'data type is not same'
			sys.exit(1)
	
		self.init_interface([data[1]])
		self.init_profile_name(data[0])
		self.init_essid([data[2]])
		if data[3] == 1:
			self.radio_button2.set_active(True)

			value = data[4]

			self.entry_ip1.set_text(value[0].split('.')[0])
			self.entry_ip2.set_text(value[0].split('.')[1])
			self.entry_ip3.set_text(value[0].split('.')[2])
			self.entry_ip4.set_text(value[0].split('.')[3].split('\n')[0])

			self.entry_gate.set_text(value[1].split('.')[0])
			self.entry_net2.set_text(value[1].split('.')[1])
			self.entry_net3.set_text(value[1].split('.')[2])
			self.entry_net4.set_text(value[1].split('.')[3].split('\n')[0])

			self.entry_mask1.set_text(value[2].split('.')[0])
			self.entry_mask2.set_text(value[2].split('.')[1])
			self.entry_mask3.set_text(value[2].split('.')[2])
			self.entry_mask4.set_text(value[2].split('.')[3].split('\n')[0])

	def get_radio(self):
		if self.radio_button1.get_active():
			return 0
		return 1

	def get_ipaddress(self):
		ip1 = self.entry_ip1.get_text()
		ip2 = self.entry_ip2.get_text()
		ip3 = self.entry_ip3.get_text()
		ip4 = self.entry_ip4.get_text()

		if not ip1 or not ip2 or not ip3 or not ip4:
			return 0

		n_ip = string.atoi(ip1)
		if (n_ip < 0) or (n_ip > 255):
			print 'ERROR : not ipaddress value'
			return 0
		n_ip = string.atoi(ip2)
		if (n_ip < 0) or (n_ip > 255):
			print 'ERROR : not ipaddress value'
			return 0
		n_ip = string.atoi(ip3)
		if (n_ip < 0) or (n_ip > 255):
			print 'ERROR : not ipaddress value'
			return 0
		n_ip = string.atoi(ip4)
		if (n_ip < 0) or (n_ip > 255):
			print 'ERROR : not ipaddress value'
			return 0
	
		return ip1 + "." + ip2 + "." + ip3 + "." + ip4

	def get_network(self):
		net1 = self.entry_gate.get_text()
		net2 = self.entry_net2.get_text()
		net3 = self.entry_net3.get_text()
		net4 = self.entry_net4.get_text()

		if not net1 or not net2 or not net3 or not net4:
			return 0

		n_net = string.atoi(net1)
		if n_net < 0 or n_net > 255:
			print 'ERROR : not gateway value'
			return 0
		n_net = string.atoi(net2)
		if n_net < 0 or n_net > 255:
			print 'ERROR : not gateway value'
			return 0
		n_net = string.atoi(net3)
		if n_net < 0 or n_net > 255:
			print 'ERROR : not gateway value'
			return 0
		n_net = string.atoi(net4)
		if n_net < 0 or n_net > 255:
			print 'ERROR : not gateway value'
			return 0

		return net1 + "." + net2 + "." + net3 + "." + net4

	def get_netmask(self):
		mask1 = self.entry_mask1.get_text()
		mask2 = self.entry_mask2.get_text()
		mask3 = self.entry_mask3.get_text()
		mask4 = self.entry_mask4.get_text()
		
		if not mask1 or not mask2 or not mask3 or not mask4:
			return 0

		n_mask = string.atoi(mask1)
		if n_mask < 0 or n_mask > 255:
			print 'ERROR : not netmask value'
			return 0
		n_mask = string.atoi(mask2)
		if n_mask < 0 or n_mask > 255:
			print 'ERROR : not netmask value'
			return 0
		n_mask = string.atoi(mask3)
		if n_mask < 0 or n_mask > 255:
			print 'ERROR : not netmask value'
			return 0
		n_mask = string.atoi(mask4)
		if n_mask < 0 or n_mask > 255:
			print 'ERROR : not netmask value'
			return 0

		return mask1 + "." + mask2 + "." + mask3 + "." + mask4

##### Callback Functions
	def callback_static_radio_button(self, widget, entry, frame):
		frame.set_sensitive(True)
		self.radio_flag = True
	
	def callback_dhcp_radio_button(self, widget, entry, frame):
		frame.set_sensitive(False)
		self.radio_flag = False

	def callback_ok_button(self, widget, entry, window):
		'''for override'''
		pass


	def __init__(self, parent_widget):
		self.parent = parent_widget
		self.init_dialog()
	
	def destroy(self, widget, data=None):
		pass
