#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk
import gobject

import net_device_manager

class DlgAccess:
	def __init__(self):
		self.init_dialog()

	def init_dialog(self):
		self.dialog = gtk.Dialog( _('Connect') )
		self.dialog.set_size_request(300,100)
		
		self.label = gtk.Label( _('Connecting...') )
		self.label.show()
		self.dialog.vbox.pack_start(self.label, True, True, 0)

		self.bar = gtk.ProgressBar()
		self.bar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
		self.bar.show()
		self.dialog.vbox.pack_start(self.bar, False, True, 0)
		
		self.source_id = gobject.timeout_add(100, self.timeout_callback)

		hbox = gtk.HBox(False, 1)
		hbox.set_border_width(1)
		hbox.show()
		self.dialog.vbox.pack_start(hbox, False, True, 0)

		#self.dialog.add_buttons("Close", gtk.RESPONSE_CLOSE)
		#self.dialog.set_response_sensitive(gtk.RESPONSE_CLOSE, False)
		self.button = gtk.Button("OK", gtk.STOCK_OK)
		self.button.connect("clicked", self.callback_button_ok)
		self.button.set_sensitive(False)
		self.button.show()
		hbox.pack_end(self.button, False, True, 0)

	def run(self, interface=None):
		if not interface:
			print 'argument is failed'
			sys.exit(1)

		ret = net_device_manager.network_restart_ext(self.dialog, interface)
		if ret == 100:
			self.complete()
		elif ret == gtk.RESPONSE_DELETE_EVENT:
			self.fail()
		else:
			print 'Ooops!!', ret
			sys.exit(1)

	def complete(self):
		self.label.set_text( _('Complete') )
		self.bar.set_fraction(1)
		gobject.source_remove(self.source_id)
		#self.dialog.set_response_sensitive(gtk.RESPONSE_CLOSE, True)
		self.button.set_sensitive(True)

	def fail(self):
		self.label.set_text( _('Fail') )
		self.bar.set_fraction(1)
		gobject.source_remove(self.source_id)
		#self.dialog.set_response_sensitive(gtk.RESPONSE_CLOSE, True)
		self.button.set_sensitive(True)

######################
# Callback Functions #
######################

	def callback_button_ok(self, button, data=None):
		self.dialog.destroy()
	
	def timeout_callback(self):
		self.bar.pulse()
		return True
