#!/usr/bin/env python
# vim:ts=8:sw=4

import pygtk
pygtk.require('2.0')
import os
import gtk
import sys

sys.path.append('../backend')
import basedlg
import ap_scan
import dlg_error

class DlgAP(basedlg.BaseDialogClass):
	def set_essid(self, essid):
		self.combo_essid.entry.set_text(essid)
			
	def init_essid(self, essid_list=None):
		if essid_list:
			self.combo_essid.set_popdown_strings(essid_list)
		else:
			self.combo_essid.set_popdown_strings(ap_scan.get_ap_list())

	def set_dialog_data(self, data=None):
		if not data:
			print 'argument is nothing'
			sys.exit(1)
		if type(data) != type([]):
			print 'data type is not same'
			sys.exit(1)
	
		self.init_interface([data[1]])
		self.init_profile_name(data[0])
		self.entry_profile.set_sensitive(False)
		self.init_essid([data[2]])
		self.combo_essid.set_sensitive(False)
		if data[3] == 1:
			self.radio_button2.set_active(True)

			value = data[4]

			self.entry_ip1.set_text(value[0].split('.')[0])
			self.entry_ip2.set_text(value[0].split('.')[1])
			self.entry_ip3.set_text(value[0].split('.')[2])
			self.entry_ip4.set_text(value[0].split('.')[3].split('\n')[0])

			self.entry_gate.set_text(value[1].split('.')[0])
			self.entry_net2.set_text(value[1].split('.')[1])
			self.entry_net3.set_text(value[1].split('.')[2])
			self.entry_net4.set_text(value[1].split('.')[3].split('\n')[0])

			self.entry_mask1.set_text(value[2].split('.')[0])
			self.entry_mask2.set_text(value[2].split('.')[1])
			self.entry_mask3.set_text(value[2].split('.')[2])
			self.entry_mask4.set_text(value[2].split('.')[3].split('\n')[0])

######################
# Callback Functions #
######################
	def callback_ok_button(self, widget, entry, window):
		print 'ok_button clicked'

		profile = self.entry_profile.get_text()
		interface = self.combo_interface.entry.get_text()
		if interface == 'Nothing':
			print 'setting interface'
		essid = self.combo_essid.entry.get_text()

		if self.radio_flag:
			ipaddr = self.get_ipaddress()
			if ipaddr == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError( _('Again insert value') )
				return 0
			
			network = self.get_network()
			if network == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError( _('Again insert value') )
				return 0
			netmask = self.get_netmask()
			if netmask == 0:
				print 'ERROR dialog'
				error = dlg_error.DlgError( _('Again insert value') )
				return 0
	
		dic_data = {}
		dic_data['profile'] = profile
		dic_data['interface'] = interface
		dic_data['essid'] = essid

		if self.get_radio() == 0:
			dic_data['radio'] = 'dhcp'
		else:
			dic_data['radio'] = 'static'
			dic_data['ip'] = ipaddr
			dic_data['network'] = network
			dic_data['netmask'] = netmask

		window.destroy()
		self.parent.return_dialog_data(dic_data)

	def __init__(self, parent_widget, name=None):
		basedlg.BaseDialogClass.__init__(self, parent_widget)
		if name:
			basedlg.BaseDialogClass.set_title(name)

		self.profile_layout.hide()
		self.init_interface()
