#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk

class DlgError:
	def __init__(self, message, title=None):
		self.init_dialog()
		self.set_label(message)
		if title != None:
			self.set_title(title)

	def set_title(self, str=None):
		if str == None:
			return 0, '타이틀 메시지가 전달되지 않았습니다.'
		self.window.set_title(str)

	def set_label(self, message=None):
		if message == None:
			return 0, '에러 메시지가 없습니다.'
		self.label.set_text(message)
		
	def callback_ok_button(self, widget, data=None):
		self.window.destroy()

	def init_dialog(self):
	    	self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.window.set_border_width(5)
		self.window.set_size_request(300, 100)
		self.window.set_modal(True)

		self.window.set_title("Error Dialog")
		self.window.set_resizable(False)
		
		vbox = gtk.VBox()
		self.window.add(vbox)
		vbox.show()

		self.label = gtk.Label()
		self.label.show()
		vbox.pack_start(self.label, False, False, 0)
		
		button_ok = gtk.Button("OK", gtk.STOCK_OK)
		button_ok.set_size_request(100,30)
		button_ok.connect("clicked", self.callback_ok_button, "ok")
		button_ok.show()
		vbox.pack_end(button_ok, False, False, 0)

		self.window.show()
