%define _distro		booyo

Summary	: Wireless AP Search and/or management tool
Name	: potamia-config-wireless
Version	: 1.0.1.050804
Release	: 1.%{_distro}
License	: GPL
Group	: System Environment/Base
URL	: http://kldp.net/projects/booyo-wireless
Source	: %{name}-%{version}.tar.gz

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Requires: python >= 2.3.4
Requires: wireless-tools >= 27
Requires: initscripts
Requires: usermode >= 1.74

Obsoletes: potamia-config-wireless
Obsoletes: booyo-config-wireless
Obsoletes: leha-APSearcher

%description
This package contain the Wireless AP search and/or management tool,

%prep
%setup -n booyo-wireless

%{__cat} <<EOF >%{name}.apps
USER=root
PROGRAM=%{_sbindir}/potamia-config-wireless
SESSION=true
FALLBACK=false
EOF

%{__cat} <<EOF >%{name}.pam
#%PAM-1.0
auth    sufficient      /lib/security/pam_rootok.so
auth    sufficient      /lib/security/pam_timestamp.so
auth    required        /lib/security/pam_stack.so service=system-auth
session required        /lib/security/pam_permit.so
session optional        /lib/security/pam_xauth.so
session optional        /lib/security/pam_timestamp.so
account required        /lib/security/pam_permit.so
EOF

%build

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install

rm -f %{buildroot}%{_sysconfdir}/security/console.apps/potamia-config-wireless.py
rm -f %{buildroot}%{_sysconfdir}/pam.d/potamia-config-wireless.py

# Install the consolehelper symlink
%{__mkdir_p} %{buildroot}%{_bindir}
%{__ln_s} consolehelper %{buildroot}%{_bindir}/potamia-config-wireless
%{__ln_s} ../share/potamia-config-wireless/frontend/potamia-config-wireless.py %{buildroot}%{_sbindir}/potamia-config-wireless

# Install the consolehelper required files
%{__install} -D -m 0644 %{name}.apps \
    %{buildroot}%{_sysconfdir}/security/console.apps/potamia-config-wireless
%{__install} -D -m 0644 %{name}.pam \
    %{buildroot}%{_sysconfdir}/pam.d/potamia-config-wireless


%clean
rm -rf $RPM_BUILD_ROOT

%post 

%postun 

%files
%defattr(-,root,root)
%{_bindir}/potamia-config-wireless
%{_sbindir}/potamia-config-wireless
%{_datadir}/potamia-config-wireless/README
%{_datadir}/potamia-config-wireless/backend/ap_scan.py
%{_datadir}/potamia-config-wireless/backend/ifcfg_manager.py
%{_datadir}/potamia-config-wireless/backend/net_device_manager.py
%{_datadir}/potamia-config-wireless/backend/profile_manager.py
%{_datadir}/potamia-config-wireless/frontend/basedlg.py
%{_datadir}/potamia-config-wireless/frontend/dlg_ap.py
%{_datadir}/potamia-config-wireless/frontend/dlg_profile.py
%{_datadir}/potamia-config-wireless/frontend/gui_ap.py
%{_datadir}/potamia-config-wireless/frontend/potamia-config-wireless.py
%{_datadir}/potamia-config-wireless/frontend/gui_profile.py
%{_datadir}/potamia-config-wireless/frontend/gui_status.py
%{_datadir}/potamia-config-wireless/frontend/dlg_error.py
%{_datadir}/applications/potamia-config-wireless.desktop
%{_datadir}/icons/Booyohaans/48x48/potamia-config-wireless.png
%{_datadir}/locale/ko/LC_MESSAGES/potamia-config-wireless.mo
/etc/pam.d/potamia-config-wireless
/etc/security/console.apps/potamia-config-wireless

%changelog
* Thu Jul 07 2005 JinkoO Han <kslee@haansoft.com> - 1.0.1.050804-1.booyo
- Change PROJECT name, potamia from booyo
- And code refactoring

* Thu Jul 07 2005 JinkoO Han <kslee@haansoft.com> - 1.0-15.booyo
- change source, because when user clicked icon, NOT running
- Modify .desktop file

* Thu Jul 07 2005 JinkoO Han <kslee@haansoft.com> - 1.0-14.booyo
- Change name leha-APSearcher to booyo-config-wireless
- Change CVS-repository cvs.booyo-wireless.kdlp.net and Apply draft-1

* Wed Jul 06 2005 JinkoO Han <kslee@haansoft.com> - 1.0-13.booyo
- Change patch(#700) name
- Change profile storage path

* Mon Jun 27 2005 Kyuseok Lee <kslee@haansoft.com>
- rename package ; booyo-config-wireless
- use custom pam and usermode conf

* Mon Jun 27 2005 JinkoO Han <jkhan@haansoft.com>
- Add po
- Check usermode
- Apply beta-5

* Wed Jun 15 2005 JinkoO Han <jkhan@haansoft.com>
- Add po
- Apply beta-4

* Tue May 31 2005 JinkoO Han <jkhan@haansoft.com>
- Apply beta-3
- beta-3 modified blcking ui from the alpha-3

* Mon May 23 2005 JinkoO Han <jkhan@haansoft.com>
- Modify category in .desktop

* Tue May 17 2005 JinkoO Han <jkhan@haansoft.com>
- Rebuild
- Icon %%files addition

* Fri May 13 2005 JinkoO Han <jkhan@haansoft.com>
- Rebuild tag name 'beta-1'

* Wed May 11 2005 JinkoO Han <jkhan@haansoft.com>
- Rebuild tag name 'alpha-3'

* Mon May 09 2005 JinkoO Han <jkhan@haansoft.com>
- Change file name, gui_main.py to leha-APSearcher.py

* Mon May 09 2005 JinkoO Han <jkhan@haansoft.com>
- Add requires
- python and wireless-tools

* Fri May 06 2005 JinkoO Han <jkhan@haansoft.com>
- make init SPEC
